SystemOrganization addCategory: 'OB-Monticello-Browser'!
SystemOrganization addCategory: 'OB-Monticello-Commands'!
SystemOrganization addCategory: 'OB-Monticello-Nodes'!
SystemOrganization addCategory: 'OB-Monticello-Other'!

!MCVersionDependency methodsFor: '*ob-monticello' stamp: 'dkh 03/04/2008 12:55'!
asNode

	^MCVersionDependencyNode new 
		dependency: self;
		yourself! !

!OBFixedButtonPanel methodsFor: '*ob-monticello' stamp: 'avi 12/4/2007 09:34'!
next
	^ browser navigationPanel currentColumn next! !

!MCDictionaryRepository methodsFor: '*ob-monticello' stamp: 'dkh 01/09/2008 16:46'!
versionNodes
	^ self dictionary keys collect: [:versionInfo | MCDictionaryBasedVersionNode versionName: versionInfo name repository: self]	! !

OBNode subclass: #MCNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

MCNode subclass: #MCAllRepositoriesNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCAllRepositoriesNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:35'!
canAddRepository

	^true! !

!MCAllRepositoriesNode methodsFor: 'navigating' stamp: 'avi 12/6/2007 14:06'!
fileBasedRepositories
	^ self repositories select: [:ea | ea repository isKindOf: MCFileBasedRepository]! !

!MCAllRepositoriesNode methodsFor: 'public' stamp: 'dkh 09/14/2007 07:20'!
name
	^ '--all repositories--'! !

!MCAllRepositoriesNode methodsFor: 'navigating' stamp: 'dkh 09/14/2007 07:30'!
repositories
	| rg |
	rg := self repositoryGroup.
	^ rg repositories collect: [:ea | | node |
		node := ea asNode.
		node repositoryGroup: rg.
		node]! !

!MCAllRepositoriesNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:30'!
repositoryGroup
	^ MCRepositoryGroup default ! !

MCNode subclass: #MCAllWorkingCopiesNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCAllWorkingCopiesNode methodsFor: 'public' stamp: 'avi 12/6/2007 13:30'!
name
	^ '--working copies--'! !

!MCAllWorkingCopiesNode methodsFor: 'navigating' stamp: 'dkh 12/14/2007 11:16'!
packages
	^ (Array with: MCAllRepositoriesNode new), super packages! !

MCNode subclass: #MCAncestryAwareNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

MCNode subclass: #MCAncestryNode
	instanceVariableNames: 'ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCAncestryNode class methodsFor: 'instance creation' stamp: 'dkh 09/13/2007 15:35'!
on: anAncestry
	^ self new
		ancestry: anAncestry;
		yourself! !

!MCAncestryNode methodsFor: 'accessing' stamp: 'dkh 09/13/2007 15:36'!
ancestry

	^ancestry! !

!MCAncestryNode methodsFor: 'accessing' stamp: 'dkh 09/13/2007 15:36'!
ancestry: anAncestry

	ancestry := anAncestry! !

!MCAncestryNode methodsFor: 'public' stamp: 'dkh 09/13/2007 15:40'!
name

	^ancestry name! !

!MCAncestryNode methodsFor: 'public' stamp: 'dkh 09/13/2007 15:46'!
text

	^ancestry summary! !

MCNode subclass: #MCBranchNode
	instanceVariableNames: 'repoWC branch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCBranchNode class methodsFor: 'as yet unclassified' stamp: 'avi 12/6/2007 14:39'!
parent: parent branch: aString
	^ self basicNew initializeWithParent: parent branch: aString! !

!MCBranchNode class methodsFor: 'as yet unclassified' stamp: 'avi 12/6/2007 14:45'!
versions
	! !

!MCBranchNode methodsFor: 'as yet unclassified' stamp: 'avi 12/6/2007 14:39'!
initializeWithParent: parent branch: aString
	repoWC _ parent.
	branch _ aString! !

!MCBranchNode methodsFor: 'as yet unclassified' stamp: 'avi 12/6/2007 15:51'!
name
	^ branch isEmptyOrNil
		ifTrue: ['--trunk--']
		ifFalse: [branch]! !

!MCBranchNode methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:20'!
versions
	^ (repoWC versionNames select: [:ea | (repoWC branchNameFor: ea) = branch]) collect:
		[:ea |
		MCFileBasedVersionNode 
			name: ea
			user: ''
			versionNumber: ''
			filename: ea]! !

MCNode subclass: #MCConfigurationNode
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCConfigurationNode class methodsFor: 'instance creation' stamp: 'dkh 03/04/2008 12:38'!
on: anMCConfiguration

	^self new 
		configuration: anMCConfiguration;
		yourself! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:38'!
configuration

	^configuration! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:38'!
configuration: anMCConfiguration

	configuration := anMCConfiguration! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:43'!
dependencies

	^self configuration dependencies! !

!MCConfigurationNode methodsFor: 'testing' stamp: 'dkh 03/04/2008 12:41'!
hasConfiguration

	^true! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:39'!
repositories

	^self configuration repositories collect: [:ea | ea asNode ].! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:04'!
text

	^''! !

!MCConfigurationNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:07'!
versions

	^self configuration dependencies collect: [:ea | | node |
		node := ea asNode.
		node configuration: self ].! !

!MCNode methodsFor: 'conversion' stamp: 'dkh 11/01/2007 16:19'!
asNode

	^self! !

!MCNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:35'!
canAddRepository

	^false! !

!MCNode methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:03'!
canBeBrowsed
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:04'!
hasAncestry
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:34'!
hasChanges
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'dkh 03/04/2008 12:41'!
hasConfiguration
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:04'!
hasRepository
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:30'!
hasRepositoryGroup

	^false! !

!MCNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:04'!
hasVersion
	^ false! !

!MCNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:04'!
hasWorkingCopy
	^ false! !

!MCNode methodsFor: 'conversion' stamp: 'avi 12/5/2007 16:30'!
isVersionNode
	^ false! !

!MCNode methodsFor: 'conversion' stamp: 'avi 12/5/2007 16:29'!
isWorkingCopyNode
	^ false! !

!MCNode methodsFor: 'navigating' stamp: 'dkh 09/14/2007 07:55'!
packages
	^(MCWorkingCopy allManagers asSortedCollection:
		[ :a :b | a package name <= b package name ]) collect: [:ea | ea asNode]! !

MCNode subclass: #MCPackageNode
	instanceVariableNames: 'parent name versions repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCPackageNode class methodsFor: 'instance creation' stamp: 'avi 12/7/2007 14:17'!
name: aString repository: aRepository
	^ self basicNew initializeWithName: aString repository: aRepository! !

!MCPackageNode methodsFor: 'accessing' stamp: 'dkh 11/01/2007 16:33'!
addVersion: aVersionNode

	self versions add: aVersionNode! !

!MCPackageNode methodsFor: 'accessing' stamp: 'dkh 12/14/2007 11:17'!
branches
	| branchDict selector n |
	selector _ name ifNil: [#packageBranch] ifNotNil: [#branch].
	branchDict _ Dictionary new.
	self versions do:
		[:ea |
		n _ ea perform: selector.
		(branchDict at: n ifAbsentPut:
			[(MCPackageNode name: n repository: repository) parent: self])
				addVersion: ea].
	^ branchDict values asSortedCollection: [:a :b | a name <= b name]! !

!MCPackageNode methodsFor: 'accessing' stamp: 'dkh 12/14/2007 11:19'!
browseChanges
	| patch |
	patch := self workingCopy changesRelativeToRepository: self repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [ 
			self workingCopy modified: false.
			OBInformRequest message: 'No changes' ]
		ifFalse: [ 
				self workingCopy modified: true.
				MCPatchTool openRoot: (MCPatchNode new patch: patch)]
! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:42'!
hasAncestry
	^ self hasWorkingCopy! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:22'!
hasChanges
	^ self hasWorkingCopy! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:17'!
hasRepository
	^ true! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:21'!
hasWorkingCopy
	^ self workingCopy notNil! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:16'!
initializeWithName: aString repository: aRepository
	name _ aString.
	repository _ aRepository! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:28'!
name
	^name ifNil: ['--not loaded--']! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:34'!
parent: aPackageNode
	parent _ aPackageNode! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:17'!
repository
	^ repository! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 12:04'!
sortedVersions
	^self versions asSortedCollection: [:a :b | a versionNumber >= b versionNumber ]! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:37'!
text
	^ self workingCopy ifNotNilDo: [:wc | wc summary]! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 12:04'!
versions
	versions == nil ifTrue: [ versions := OrderedCollection new ].
	^versions! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:42'!
withBreadthFirstAncestors
	^self workingCopy ancestry withBreadthFirstAncestors collect: [:ea | ea asNode ]! !

!MCPackageNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 14:35'!
workingCopy
	^ MCWorkingCopy allManagers detect: [:ea | ea package name = self name] ifNone: [parent ifNotNil: [parent workingCopy]]! !

MCNode subclass: #MCPatchAwareNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

MCPatchAwareNode subclass: #MCConflictNode
	instanceVariableNames: 'conflict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCConflictNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 10:19'!
conflict
	^ conflict! !

!MCConflictNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 10:06'!
conflict: aConflict
	conflict _ aConflict! !

!MCConflictNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 10:14'!
name
	^ conflict summary! !

!MCConflictNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 10:15'!
text
	^ conflict source! !

!MCPatchAwareNode methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:49'!
install
	| loader |
	loader _ MCPackageLoader new.
	self operation applyTo: loader.
	loader loadWithName: 'Installed Patches'! !

MCPatchAwareNode subclass: #MCPatchOperationNode
	instanceVariableNames: 'operation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCPatchOperationNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 09:40'!
name
	^ operation summary! !

!MCPatchOperationNode methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 17:04'!
operation
	^ operation! !

!MCPatchOperationNode methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 17:04'!
operation: anOperation
	operation _ anOperation! !

!MCPatchOperationNode methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:45'!
text
	^ operation source! !

MCNode subclass: #MCPatchNode
	instanceVariableNames: 'patch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCPatchNode methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:18'!
operations
	^ patch operations collect: [:ea | MCPatchOperationNode new operation: ea]! !

!MCPatchNode methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 09:54'!
patch: aPatch
	patch _ aPatch! !

MCNode subclass: #MCRepositoryAwareNode
	instanceVariableNames: 'repository repositoryGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCRepositoryAwareNode class methodsFor: 'instance creation' stamp: 'dkh 09/14/2007 07:29'!
on: aRepository
	^ self new
		repository: aRepository;
		yourself! !

!MCRepositoryAwareNode class methodsFor: 'instance creation' stamp: 'dkh 09/14/2007 07:29'!
on: aRepository group: aRepositoryGroup
	^ self new
		repository: aRepository;
		repositoryGroup: aRepositoryGroup;
		yourself! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'dkh 12/14/2007 11:19'!
browseChanges
	| patch |
	patch := self workingCopy changesRelativeToRepository: self repository.
	patch isNil ifTrue: [^ self].
	patch isEmpty
		ifTrue: [ 
			self workingCopy modified: false.
			OBInformRequest message: 'No changes' ]
		ifFalse: [ 
				self workingCopy modified: true.
				MCPatchTool openRoot: (MCPatchNode new patch: patch)]
! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'dkh 12/14/2007 15:31'!
canAddRepository

	^self repositoryGroup notNil! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:34'!
hasChanges
	^ self hasWorkingCopy! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:21'!
hasRepository
	^ true! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:31'!
hasRepositoryGroup

	^self repositoryGroup ~~ nil! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:23'!
hasWorkingCopy
	^ self workingCopy notNil! !

!MCRepositoryAwareNode methodsFor: 'public' stamp: 'dkh 09/14/2007 07:29'!
name
	^ repository description! !

!MCRepositoryAwareNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:29'!
repository
	^ repository ! !

!MCRepositoryAwareNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:29'!
repository: aRepository
	repository := aRepository ! !

!MCRepositoryAwareNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:29'!
repositoryGroup
	^ repositoryGroup ! !

!MCRepositoryAwareNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:29'!
repositoryGroup: aRepositoryGroup
	repositoryGroup := aRepositoryGroup ! !

!MCRepositoryAwareNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:24'!
workingCopy
	^ MCWorkingCopy allManagers detect: [:ea | ea repositoryGroup = repositoryGroup] ifNone: []! !

MCRepositoryAwareNode subclass: #MCRepositoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCRepositoryNode methodsFor: 'navigating' stamp: 'avi 12/7/2007 11:55'!
packagesByBranch
	^ self packagesGroupedBy: #packageBranch! !

!MCRepositoryNode methodsFor: 'navigating' stamp: 'avi 12/7/2007 11:55'!
packagesByName
	^ self packagesGroupedBy: #packageName! !

!MCRepositoryNode methodsFor: 'navigating' stamp: 'dkh 12/20/2007 10:04'!
packagesGroupedBy: aSelector
	| versionNodes packageDict n |
	versionNodes _ self repository versionNodes.
	packageDict _ Dictionary new.
	versionNodes do:
		[:ea |
		n _ ea perform: aSelector.
		n == nil ifTrue: [ n := '--not loaded--' ].
		(packageDict at: n ifAbsentPut:
			[MCPackageNode name: n repository: repository])
				addVersion: ea].
	^ packageDict values asSortedCollection: [:a :b | a name <= b name]
! !

!MCRepositoryNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:09'!
text

	^self repository description! !

!MCRepositoryNode methodsFor: 'navigating' stamp: 'avi 12/6/2007 14:33'!
workingCopyFor: aString
	| all |
	all _ MCWorkingCopy allManagers select: [:ea | aString beginsWith: ea package name].
	all isEmpty ifTrue: [^ nil].
	^ (all detectMax: [:ea | ea package name size])! !

MCNode subclass: #MCVersionDependencyNode
	instanceVariableNames: 'configuration dependency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:07'!
configuration

	^configuration! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:07'!
configuration: anMCConfigurationNode

	configuration := anMCConfigurationNode! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:54'!
dependency

	^dependency! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:54'!
dependency: aVersionDependency

	dependency := aVersionDependency! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:56'!
name

	^self dependency versionInfo name! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:09'!
repositories

	^self configuration repositories! !

!MCVersionDependencyNode methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:05'!
text

	^self dependency versionInfo summary! !

MCNode subclass: #MCVersionMergerNode
	instanceVariableNames: 'versionMerger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCVersionMergerNode methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:18'!
conflicts
	^ versionMerger merger conflicts collect: [:ea | MCConflictNode new conflict: ea]! !

!MCVersionMergerNode methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:19'!
operations
	^ versionMerger merger operations collect: [:ea | MCPatchOperationNode new operation: ea]! !

!MCVersionMergerNode methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 16:40'!
versionMerger
	^ versionMerger! !

!MCVersionMergerNode methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 16:40'!
versionMerger: aMerger	
	versionMerger _ aMerger! !

MCNode subclass: #MCVersionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

MCVersionNode subclass: #MCDictionaryBasedVersionNode
	instanceVariableNames: 'repository versionname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCDictionaryBasedVersionNode class methodsFor: 'instance creation' stamp: 'dkh 01/09/2008 16:37'!
versionName: aString repository: aRepository 
	^ self basicNew initializeWithVersionName: aString repository: aRepository! !

!MCDictionaryBasedVersionNode methodsFor: 'initialization' stamp: 'dkh 01/09/2008 16:37'!
initializeWithVersionName: aString repository: aRepository
	repository _ aRepository.
	versionname _ aString! !

!MCDictionaryBasedVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:36'!
name
	^versionname! !

!MCDictionaryBasedVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:36'!
repository
	^ repository! !

!MCDictionaryBasedVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:41'!
version
	^ self repository versionFromVersionNamed: versionname! !

!MCDictionaryBasedVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:42'!
versionInfo
	^ self repository versionInfoFromVersionNamed: versionname! !

!MCDictionaryBasedVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:42'!
versionName
	^ repository versionNameFromVersionName: versionname! !

MCVersionNode subclass: #MCFileBasedVersionNode
	instanceVariableNames: 'repository filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCFileBasedVersionNode class methodsFor: 'instance creation' stamp: 'avi 12/7/2007 11:39'!
fileName: aString repository: aRepository 
	^ self basicNew initializeWithFileName: aString repository: aRepository! !

!MCFileBasedVersionNode methodsFor: 'initialization' stamp: 'avi 12/7/2007 11:37'!
initializeWithFileName: aString repository: aRepository
	repository _ aRepository.
	filename _ aString! !

!MCFileBasedVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 11:37'!
name
	^filename! !

!MCFileBasedVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 11:43'!
repository
	^ repository! !

!MCFileBasedVersionNode methodsFor: 'accessing' stamp: 'avi 12/3/2007 15:05'!
version
	^ self repository versionFromFileNamed: filename! !

!MCFileBasedVersionNode methodsFor: 'accessing' stamp: 'avi 12/4/2007 10:03'!
versionInfo
	^ self repository versionInfoFromFileNamed: filename! !

!MCFileBasedVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 11:40'!
versionName
	^ repository versionNameFromFileName: filename! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 12/14/2007 11:17'!
ancestryNode
	^ MCAncestryNode new ancestry: self versionInfo ancestry! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:31'!
branch
	| branch |
	branch _ self packageBranch copyAfter: $..
	branch isEmpty ifTrue: [^ ' --trunk--'].
	^ branch! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 12/14/2007 11:19'!
browseChanges
	| patch |
	patch _ self version changes.
	patch isEmpty
		ifTrue: [OBInformRequest message: 'No changes' ]
		ifFalse: [MCPatchTool openRoot: (MCPatchNode new patch: patch)]! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 13:05'!
hasAncestry
	^ true! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 13:34'!
hasChanges
	^ true! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/7/2007 13:11'!
hasVersion
	^ true! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/5/2007 16:30'!
isVersionNode
	^ true! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:32'!
name

	self subclassResponsibility! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:32'!
packageBranch
	 ^ ((self versionName copyUpToLast: $.) copyUpToLast: $-)! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:33'!
packageName
	| allNames candidates |
	allNames _ MCWorkingCopy allManagers collect: [:ea | ea package name].
	candidates _ allNames select: [:ea | self name beginsWith: ea].
	candidates isEmpty ifTrue: [^ nil].
	^ candidates detectMax: [:ea | ea size]! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/4/2007 10:03'!
text
	^ self versionInfo summary! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:33'!
versionName

	self subclassResponsibility! !

!MCVersionNode methodsFor: 'accessing' stamp: 'dkh 01/09/2008 16:34'!
versionNumber
	^ [(self versionName copyAfterLast: $.) asNumber] ifError: [0]! !

!MCVersionNode methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:58'!
withBreadthFirstAncestors
	^self versionInfo withBreadthFirstAncestors collect: [:ea | ea asNode ]! !

MCNode subclass: #MCWorkingCopyNode
	instanceVariableNames: 'package workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Nodes'!

!MCWorkingCopyNode class methodsFor: 'instance creation' stamp: 'dkh 09/14/2007 07:57'!
on: aWorkingCopy
	^ self new
		workingCopy: aWorkingCopy;
		yourself! !

!MCWorkingCopyNode methodsFor: 'accessing' stamp: 'dkh 12/14/2007 11:17'!
ancestryNode
	^ MCAncestryNode new ancestry: self workingCopy ancestry! !

!MCWorkingCopyNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:57'!
canAddRepository

	^true! !

!MCWorkingCopyNode methodsFor: 'testing' stamp: 'dkh 09/14/2007 07:57'!
canBeBrowsed
	^ true! !

!MCWorkingCopyNode methodsFor: 'changes' stamp: 'dkh 11/05/2007 09:13'!
changesRelativeToRepository: aReposistoryNode

	^self workingCopy changesRelativeToRepository: aReposistoryNode repository.
	! !

!MCWorkingCopyNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:05'!
hasAncestry
	^ true! !

!MCWorkingCopyNode methodsFor: 'testing' stamp: 'avi 12/7/2007 13:05'!
hasWorkingCopy
	^ true! !

!MCWorkingCopyNode methodsFor: 'testing' stamp: 'avi 12/5/2007 16:30'!
isWorkingCopyNode
	^ true! !

!MCWorkingCopyNode methodsFor: 'accessing' stamp: 'dkh 11/05/2007 09:20'!
modified: aBool

	self workingCopy modified: aBool.
	self signalChanged! !

!MCWorkingCopyNode methodsFor: 'public' stamp: 'avi 12/4/2007 15:52'!
name
	^ self workingCopy packageName! !

!MCWorkingCopyNode methodsFor: 'public' stamp: 'dkh 09/14/2007 07:57'!
packageName

	^self workingCopy package name! !

!MCWorkingCopyNode methodsFor: 'navigating' stamp: 'dkh 09/14/2007 07:57'!
repositories
	| rg |
	rg := self repositoryGroup.
	^ rg repositories collect: [:ea | | node |
		node := ea asNode.
		node repositoryGroup: rg.
		node]! !

!MCWorkingCopyNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:57'!
repositoryGroup

	^self workingCopy repositoryGroup! !

!MCWorkingCopyNode methodsFor: 'public' stamp: 'avi 12/7/2007 14:36'!
text
	^ self workingCopy summary! !

!MCWorkingCopyNode methodsFor: 'navigating' stamp: 'dkh 09/14/2007 07:57'!
withBreadthFirstAncestors

	^self workingCopy ancestry withBreadthFirstAncestors collect: [:ea | ea asNode ]! !

!MCWorkingCopyNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:57'!
workingCopy

	^workingCopy! !

!MCWorkingCopyNode methodsFor: 'accessing' stamp: 'dkh 09/14/2007 07:57'!
workingCopy: aWorkingCopy 

	workingCopy := aWorkingCopy! !

!MCFileBasedRepository methodsFor: '*ob-monticello' stamp: 'dkh 12/14/2007 11:20'!
versionNodes
	^ self readableFileNames collect: [:ea | MCFileBasedVersionNode fileName: ea repository: self]		! !

!MCDirectoryRepository class methodsFor: '*ob-monticello' stamp: 'dkh 02/24/2008 22:32'!
obConfigureFromTemplate: aString
	| pathString |
	pathString := MCDirectoryRequest signal.
	pathString == nil ifTrue: [ ^nil ]. 
	^self new directory: (FileDirectory on: pathString)! !

OBBrowser subclass: #MCBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

MCBrowser subclass: #MCAllRepositoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCAllRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:22'!
defaultMetaNode
	| repos versions root branches packages |
	root _ OBMetaNode named: 'root'.
	repos _ OBMetaNode named: 'repositories'.
	packages _ OBMetaNode named: 'packages'.
	branches _ OBMetaNode named: 'branches'.
	versions _ OBMetaNode named: 'bersions'.
		
	root - #fileBasedRepositories -> repos.
	repos - #packagesByName -> packages.
	packages - #branches -> branches.
	branches - #sortedVersions -> versions.
	
	packages autoSelect: branches.
	packages addFilter: MCModifiedFilter new.
	^ root! !

!MCAllRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:16'!
defaultRootNode
	^ MCAllRepositoriesNode new! !

!MCAllRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'avi 12/6/2007 14:01'!
paneCount
	^ 4! !

!MCAllRepositoryBrowser class methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 15:50'!
title
	^ 'Monticello'! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/19/2007 09:27'!
cmdAdmin
	^ {MCCmdNewRepository}! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:09'!
cmdChanges
	^ MCCmdChanges! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:10'!
cmdHistory
	^ MCCmdHistory! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:11'!
cmdRefresh
	^ MCCmdRefresh ! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:12'!
cmdRepository
	^ {MCCmdEditRepositoryInfo}! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:12'!
cmdVersions
	^ MCVersionCommand allSubclasses! !

!MCAllRepositoryBrowser methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:14'!
cmdWorkingCopyRepository
	^ MCWorkingCopyRepositoryCommand allSubclasses! !

!MCBrowser class methodsFor: 'configuration' stamp: 'dkh 12/19/2007 10:48'!
optionalButtonPanel
	"make optional button panel, non-optional for MCBrowsers"
	
	^ OBFixedButtonPanel new! !

!MCBrowser methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 15:37'!
defaultBackgroundColor
	^ Color r: 0.627 g: 0.69 b: 0.976! !

MCBrowser subclass: #MCCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCCodeBrowser class methodsFor: 'configuration' stamp: 'dkh 11/05/2007 08:23'!
annotationPanel
	^ OBPlatform current annotationPanes ifTrue: [ OGAnnotationPanel new ]! !

MCCodeBrowser subclass: #MCMergeTool
	instanceVariableNames: 'versionMerger title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCMergeTool class methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 17:04'!
defaultMetaNode
	| merger conflicts ops |
	merger := OBMetaNode named: 'VersionMerger'.
	conflicts := OBMetaNode named: 'Conflicts'.
	ops := OBMetaNode named: 'Operations'.
	merger childAt: #conflicts put: conflicts.
	merger childAt: #operations put: ops.
	^ merger! !

!MCMergeTool class methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 16:48'!
paneCount
	^ 1! !

!MCMergeTool class methodsFor: 'as yet unclassified' stamp: 'avi 12/3/2007 16:52'!
titleForRoot: aNode
	^ aNode versionMerger mergeTitle! !

!MCMergeTool methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:10'!
cmdInstall
	^ MCCmdInstallOperation ! !

!MCMergeTool methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:12'!
cmdStandard
	^ {MCCmdFinishMerge. MCCmdKeepConflict. MCCmdRejectConflict}! !

MCCodeBrowser subclass: #MCPatchTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCPatchTool class methodsFor: 'configuration' stamp: 'avi 12/4/2007 09:55'!
defaultMetaNode
	| operations  patch |
	patch := OBMetaNode named: 'Patch'.
	operations := OBMetaNode named: 'Operations'.
	patch - #operations -> operations.
	^ patch! !

!MCPatchTool class methodsFor: 'configuration' stamp: 'dkh 11/05/2007 08:32'!
paneCount
	^ 1! !

!MCPatchTool class methodsFor: 'configuration' stamp: 'dkh 11/05/2007 08:49'!
title
	^ 'Patch Browser'! !

!MCPatchTool methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:10'!
cmdInstall
	^ MCCmdInstallOperation ! !

MCBrowser subclass: #MCConfigurationTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCConfigurationTool class methodsFor: 'configuration' stamp: 'dkh 03/04/2008 13:07'!
defaultMetaNode
	| configuration repositories versions |
	configuration := OBMetaNode named: 'configuration'.
	versions := OBMetaNode named: 'versions'.
	repositories := OBMetaNode named: 'repositories'.
	configuration - #versions -> versions.
	versions - #repositories -> repositories.
	^ configuration
! !

!MCConfigurationTool class methodsFor: 'configuration' stamp: 'dkh 03/04/2008 12:39'!
defaultRootNode
	^ MCConfigurationNode on: MCConfiguration new.! !

!MCConfigurationTool class methodsFor: 'configuration' stamp: 'dkh 03/04/2008 13:08'!
paneCount
	^ 2! !

!MCConfigurationTool class methodsFor: 'configuration' stamp: 'dkh 03/04/2008 12:32'!
title
	^ 'MCConfiguration Browser'! !

!MCConfigurationTool methodsFor: 'commands' stamp: 'dkh 03/04/2008 12:40'!
cmdConfigurations
	^ MCCmdConfiguration allSubclasses ! !

MCBrowser subclass: #MCDependencyBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

MCBrowser subclass: #MCPackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCPackageBrowser class methodsFor: 'configuration' stamp: 'dkh 12/14/2007 11:22'!
defaultMetaNode
	| allPackages packages repositories |
	allPackages := OBMetaNode named: 'All packages'.
	packages := OBMetaNode named: 'Packages'.
	allPackages childAt: #packages put: packages.
	packages addFilter: MCModifiedFilter new.
	repositories := OBMetaNode named: 'Repositories'.
	packages childAt: #repositories put: repositories.
	^ allPackages! !

!MCPackageBrowser class methodsFor: 'configuration' stamp: 'dkh 12/14/2007 11:16'!
defaultRootNode
	^ MCAllWorkingCopiesNode new! !

!MCPackageBrowser class methodsFor: 'configuration' stamp: 'dkh 11/05/2007 08:32'!
paneCount
	^ 2! !

!MCPackageBrowser class methodsFor: 'configuration' stamp: 'dkh 09/12/2007 19:00'!
title
	^ 'Monticello Browser'! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:09'!
cmdAdmin
	^ MCAdminCommand allSubclasses! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:09'!
cmdChanges
	^ MCCmdChanges! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:10'!
cmdHistory
	^ MCCmdHistory! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:12'!
cmdRepository
	^ MCRepositoryCommand allSubclasses! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:13'!
cmdWorkingCopy
	^ MCWorkingCopyCommand allSubclasses! !

!MCPackageBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:14'!
cmdWorkingCopyRepository
	^ MCWorkingCopyRepositoryCommand allSubclasses! !

MCBrowser subclass: #MCRepositoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCRepositoryBrowser class methodsFor: 'configuration' stamp: 'avi 12/7/2007 11:59'!
defaultMetaNode
	| packages repository versions |
	repository := OBMetaNode named: 'repository'.
	packages := OBMetaNode named: 'packages'.
	versions := OBMetaNode named: 'version'.
	repository childAt: #packagesByBranch put: packages.
	packages childAt: #sortedVersions put: versions.
	^ repository
! !

!MCRepositoryBrowser class methodsFor: 'configuration' stamp: 'dkh 9/12/2007 16:00'!
paneCount
	^ 2! !

!MCRepositoryBrowser class methodsFor: 'configuration' stamp: 'dkh 09/12/2007 16:46'!
title
	^ 'Repository Browser'! !

!MCRepositoryBrowser class methodsFor: 'configuration' stamp: 'avi 12/4/2007 15:41'!
titleForRoot: aNode
	^ 'Repository: ', aNode name! !

!MCRepositoryBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:13'!
cmdAll
	^ MCVersionCommand allSubclasses! !

!MCRepositoryBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:09'!
cmdChanges
	^ MCCmdChanges! !

!MCRepositoryBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:10'!
cmdHistory
	^ MCCmdHistory! !

!MCRepositoryBrowser methodsFor: 'commands' stamp: 'dkh 12/14/2007 11:11'!
cmdRefresh
	^ MCCmdRefresh ! !

MCBrowser subclass: #MCVersionHistoryTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Browser'!

!MCVersionHistoryTool class methodsFor: 'configuration' stamp: 'dkh 09/13/2007 15:45'!
defaultMetaNode
	| ancestor ancestors |
	ancestor := OBMetaNode named: 'Ancestor'.
	ancestors := OBMetaNode named: 'Ancestors'.
	ancestor childAt: #withBreadthFirstAncestors put: ancestors.
	^ ancestor! !

!MCVersionHistoryTool class methodsFor: 'instance creation' stamp: 'dkh 09/13/2007 15:28'!
onPackage: aPackageNode
	^self root: aPackageNode! !

!MCVersionHistoryTool class methodsFor: 'instance creation' stamp: 'dkh 09/13/2007 15:28'!
openOnPackage: aPackageNode
	^(self onPackage: aPackageNode) open! !

!MCVersionHistoryTool class methodsFor: 'configuration' stamp: 'dkh 09/13/2007 15:45'!
paneCount
	^ 1! !

!MCVersionHistoryTool class methodsFor: 'configuration' stamp: 'dkh 09/13/2007 15:45'!
panels
	^ Array with: self navigationPanel with:  self definitionPanel
		
	! !

!MCVersionHistoryTool class methodsFor: 'configuration' stamp: 'avi 12/4/2007 16:16'!
title
	^'Version History'! !

!MCRepository class methodsFor: '*ob-monticello' stamp: 'avi 12/5/2007 11:03'!
obConfigure
	^ self obConfigureFromTemplate: nil! !

!MCRepository methodsFor: '*ob-monticello' stamp: 'dkh 12/14/2007 11:19'!
asNode
	^ MCRepositoryNode on: self! !

!MCRepository methodsFor: '*ob-monticello' stamp: 'avi 12/5/2007 11:08'!
obConfigure
	^ self class obConfigureFromTemplate: self asCreationTemplate! !

!MCRepository methodsFor: '*ob-monticello' stamp: 'dkh 11/01/2007 16:01'!
packageNodes

	self subclassResponsibility! !

OBCommand subclass: #MCCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCCommand subclass: #MCAdminCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCAdminCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 15:10'!
group
	^ #admin! !

MCAdminCommand subclass: #MCCmdNewPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdNewPackage methodsFor: 'execution' stamp: 'dkh 09/13/2007 13:37'!
execute
	| name workingCopy |
	name := OBTextRequest
			prompt: 'Name of package:'
			template: ''.
	name isEmptyOrNil ifFalse:
		[PackageInfo registerPackageName: name.
		workingCopy := MCWorkingCopy forPackage: (MCPackage new name: name).
		self refresh].! !

!MCCmdNewPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:12'!
label
	^ 'add package'! !

!MCCmdNewPackage methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:07'!
wantsButton
	^ true! !

MCAdminCommand subclass: #MCCmdNewRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdNewRepository methodsFor: 'execution' stamp: 'dkh 02/27/2008 14:13'!
execute

	| types labels cls repos |
	types := MCRepository allConcreteSubclasses asArray.
	labels := types collect: [:ea | ea description].
	cls := OBChoiceRequest 
		prompt: 'Repository type:' 
		labels: labels
		values: types.
	cls == nil ifTrue: [ ^self ].
	repos := cls obConfigure.
	repos ~~ nil ifTrue: [ target repositoryGroup addRepository: repos ].
	self refresh! !

!MCCmdNewRepository methodsFor: 'testing' stamp: 'avi 12/4/2007 15:14'!
isActive
	^ super isActive and: [target canAddRepository]! !

!MCCmdNewRepository methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:12'!
label
	^ 'add repository'! !

!MCCmdNewRepository methodsFor: 'testing' stamp: 'dkh 12/14/2007 15:21'!
wantsButton
	^ true! !

MCCommand subclass: #MCCmdBrowsePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdBrowsePackage methodsFor: 'execution' stamp: 'dkh 9/12/2007 16:05'!
execute
	target browse! !

!MCCmdBrowsePackage methodsFor: 'testing' stamp: 'avi 12/4/2007 15:00'!
isActive
	^ super isActive and: [target canBeBrowsed]! !

!MCCmdBrowsePackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:12'!
label
	^ 'browse'! !

!MCCmdBrowsePackage methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:05'!
wantsButton
	^ true! !

MCCommand subclass: #MCCmdChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdChanges methodsFor: 'execution' stamp: 'avi 12/7/2007 13:33'!
execute
	target browseChanges! !

!MCCmdChanges methodsFor: 'testing' stamp: 'avi 12/7/2007 13:33'!
isActive
	^ target hasChanges and: [requestor isSelected: target]! !

!MCCmdChanges methodsFor: 'accessing' stamp: 'avi 12/7/2007 13:33'!
label
	^ 'changes'! !

!MCCmdChanges methodsFor: 'testing' stamp: 'avi 12/7/2007 13:33'!
wantsButton
	^ true! !

MCCommand subclass: #MCCmdConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCCmdConfiguration subclass: #MCCmdAddDependency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdAddDependency methodsFor: 'accessing' stamp: 'dkh 03/04/2008 13:03'!
dependencies

	^requestor browser root dependencies! !

!MCCmdAddDependency methodsFor: 'execution' stamp: 'dkh 03/04/2008 12:43'!
execute

	(self pickWorkingCopiesSatisfying: [:each | (self includesPackage: each package) not])
		do: [:wc |
			wc ancestors isEmpty
				ifTrue: [self inform: 'You must save ', wc packageName, ' first!!
Skipping this package']
				ifFalse: [
					self dependencies add: (MCVersionDependency
						package: wc package
						info: wc ancestors first)]].
	self refresh! !

!MCCmdAddDependency methodsFor: 'testing' stamp: 'dkh 03/04/2008 12:43'!
includesPackage: aPackage
	^self dependencies anySatisfy: [:each | each package = aPackage]! !

!MCCmdAddDependency methodsFor: 'testing' stamp: 'dkh 03/04/2008 13:01'!
isActive
	^ true! !

!MCCmdAddDependency methodsFor: 'accessing' stamp: 'dkh 03/04/2008 12:28'!
label
	^ 'add dependency'! !

!MCCmdAddDependency methodsFor: 'testing' stamp: 'dkh 03/04/2008 12:41'!
wantsButton
	^ true! !

!MCCmdConfiguration methodsFor: 'testing' stamp: 'dkh 03/04/2008 12:29'!
isActive

	^false! !

MCCommand subclass: #MCCmdHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdHistory methodsFor: 'executing' stamp: 'dkh 12/14/2007 10:57'!
execute
	MCVersionHistoryTool openOnPackage: target! !

!MCCmdHistory methodsFor: 'testing' stamp: 'avi 12/7/2007 13:25'!
isActive
	^ target hasAncestry and: [requestor isSelected: target]! !

!MCCmdHistory methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:15'!
label
	^ 'history'! !

!MCCmdHistory methodsFor: 'testing' stamp: 'dkh 09/13/2007 15:27'!
wantsButton
	^ true! !

MCCommand subclass: #MCCmdInspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdInspect methodsFor: 'as yet unclassified' stamp: 'dkh 9/12/2007 16:06'!
execute
	target inspect! !

!MCCmdInspect methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:51'!
group
	^ #zinspect! !

!MCCmdInspect methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:51'!
label
	^ 'inspect'! !

MCCommand subclass: #MCCmdInstallOperation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdInstallOperation methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:50'!
execute
	target install! !

!MCCmdInstallOperation methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:51'!
label
	^ 'install'! !

!MCCmdInstallOperation methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:18'!
targetClass
	^ MCPatchAwareNode! !

!MCCmdInstallOperation methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:50'!
wantsButton
	^ true! !

MCCommand subclass: #MCCmdRefresh
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRefresh methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:53'!
execute
	self refresh! !

!MCCmdRefresh methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 14:24'!
isActive
	^ target hasRepository and: [requestor isSelected: target]! !

!MCCmdRefresh methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:53'!
label
	^ 'refresh'! !

!MCCmdRefresh methodsFor: 'as yet unclassified' stamp: 'avi 12/5/2007 12:55'!
wantsButton
	^ true! !

!MCCommand methodsFor: 'testing' stamp: 'avi 12/4/2007 17:02'!
execute
	self halt! !

!MCCommand methodsFor: 'testing' stamp: 'avi 12/4/2007 15:36'!
isActive
	^ (target isKindOf: self targetClass) and: [self targetMustBeSelected not or: [requestor isSelected: target]]! !

!MCCommand methodsFor: 'actions' stamp: 'dkh 03/04/2008 12:27'!
pickWorkingCopiesSatisfying: aBlock
	| copies item |
	copies := (MCWorkingCopy allManagers select: aBlock)
		asSortedCollection: [:a :b | a packageName <= b packageName].
	item := OBChoiceRequest 
		prompt: 'Package:' 
		labels: #('match ...'),(copies collect: [:ea | ea packageName])
		values: #(match), copies.
	item == #match ifTrue: [
		| pattern |
		pattern := OBTextRequest
			prompt: 'Packages matching:'
			template: '*'.
		^pattern isEmptyOrNil
			ifTrue: [#()]
			ifFalse: [
				(pattern includes: $*) ifFalse: [pattern _ '*', pattern, '*'].
				copies select: [:ea | pattern squeakMatch: ea packageName]]
	].
	^ item == nil
		ifTrue: [#()]
		ifFalse: [{item}]! !

!MCCommand methodsFor: 'actions' stamp: 'avi 12/5/2007 11:16'!
pickWorkingCopySatisfying: aBlock
	| workingCopies |
	workingCopies := self workingCopies select: aBlock.
	workingCopies isEmpty ifTrue: [ ^nil ].
	^OBChoiceRequest 
		prompt: 'Package:' 
		labels: (workingCopies collect: [:ea | ea packageName])
		values: workingCopies.! !

!MCCommand methodsFor: 'actions' stamp: 'dkh 9/12/2007 16:05'!
refresh
	requestor announcer announce: OBRefreshRequired! !

!MCCommand methodsFor: 'testing' stamp: 'dkh 12/14/2007 15:25'!
targetClass
	^ MCNode! !

!MCCommand methodsFor: 'actions' stamp: 'avi 12/5/2007 11:10'!
targetDefinitionChanged
	requestor announce: (OBDefinitionChanged definition: target definition)! !

!MCCommand methodsFor: 'testing' stamp: 'avi 12/4/2007 14:57'!
targetMustBeSelected
	^ true! !

!MCCommand methodsFor: 'actions' stamp: 'avi 12/5/2007 11:09'!
targetNodeChanged
	requestor announce: (OBNodeChanged node: target)! !

!MCCommand methodsFor: 'actions' stamp: 'avi 12/5/2007 11:18'!
workingCopies
	^(MCWorkingCopy allManagers asSortedCollection:
		[ :a :b | a package name <= b package name ]) ! !

MCCommand subclass: #MCMergeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCMergeCommand subclass: #MCCmdFinishMerge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdFinishMerge methodsFor: 'execution' stamp: 'avi 12/5/2007 13:20'!
execute
	requestor browser root versionMerger loadWithNameLike: nil.
	requestor browser close! !

!MCCmdFinishMerge methodsFor: 'testing' stamp: 'avi 12/4/2007 10:38'!
isActive
	^ self versionMerger merger isMerged! !

!MCCmdFinishMerge methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:51'!
label
	^ 'finish merge'! !

!MCCmdFinishMerge methodsFor: 'testing' stamp: 'avi 12/4/2007 12:14'!
versionMerger
	^ requestor browser root versionMerger! !

!MCCmdFinishMerge methodsFor: 'testing' stamp: 'avi 12/4/2007 10:24'!
wantsButton
	^ true! !

MCMergeCommand subclass: #MCCmdKeepConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdKeepConflict methodsFor: 'execution' stamp: 'avi 12/5/2007 11:10'!
execute
	target conflict chooseRemote.
	self targetNodeChanged.
	self targetDefinitionChanged! !

!MCCmdKeepConflict methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:51'!
group
	^ #conflicts! !

!MCCmdKeepConflict methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:51'!
label
	^ 'keep'! !

!MCCmdKeepConflict methodsFor: 'testing' stamp: 'avi 12/4/2007 10:16'!
wantsButton
	^ true! !

MCMergeCommand subclass: #MCCmdRejectConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRejectConflict methodsFor: 'execution' stamp: 'avi 12/5/2007 11:10'!
execute
	target conflict chooseLocal.
	self targetNodeChanged.
	self targetDefinitionChanged! !

!MCCmdRejectConflict methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:51'!
group
	^ #conflicts! !

!MCCmdRejectConflict methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:51'!
label
	^ 'reject'! !

!MCCmdRejectConflict methodsFor: 'testing' stamp: 'avi 12/4/2007 10:17'!
wantsButton
	^ true! !

!MCMergeCommand methodsFor: 'as yet unclassified' stamp: 'dkh 12/14/2007 11:18'!
targetClass
	^ MCConflictNode! !

MCCommand subclass: #MCRepositoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCRepositoryCommand subclass: #MCCmdAddRepositoryToPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdAddRepositoryToPackage methodsFor: 'execution' stamp: 'dkh 09/14/2007 08:01'!
execute

		(self pickWorkingCopySatisfying: [ :p | (p repositoryGroup includes: self repository) not ]) ifNotNilDo:
			[:wc |
			wc repositoryGroup addRepository: self repository]! !

!MCCmdAddRepositoryToPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:52'!
label
	^ 'add repository to package'! !

MCRepositoryCommand subclass: #MCCmdEditRepositoryInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdEditRepositoryInfo methodsFor: 'execution' stamp: 'avi 12/5/2007 11:10'!
execute
	| newRepo |
	newRepo := target repository obConfigure.
	newRepo ifNotNil: [ 
		newRepo class = self repository class
			ifTrue: [self repository copyFrom: newRepo]
			ifFalse: [OBInformRequest message: 'Must not change repository type!!']].
	self targetNodeChanged! !

!MCCmdEditRepositoryInfo methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:56'!
label
	^ 'edit repository info'! !

MCRepositoryCommand subclass: #MCCmdFlushAllCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdFlushAllCaches methodsFor: 'execution' stamp: 'dkh 02/22/2008 13:45'!
execute

	MCRepositoryGroup default repositoriesDo: [:rep | rep flushCache ].! !

!MCCmdFlushAllCaches methodsFor: 'accessing' stamp: 'dkh 02/22/2008 13:44'!
label
	^ 'flush all caches'! !

MCRepositoryCommand subclass: #MCCmdOpenRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdOpenRepository methodsFor: 'execution' stamp: 'dkh 12/14/2007 10:55'!
execute
	MCRepositoryBrowser
		openRoot: target ! !

!MCCmdOpenRepository methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:55'!
label
	^ 'open'! !

!MCCmdOpenRepository methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:07'!
wantsButton
	^ true! !

!MCRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:51'!
group
	^ #repository! !

!MCRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 13:13'!
isActive
	^ target hasRepository and: [requestor isSelected: target]! !

!MCRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:52'!
repository
	^target repository! !

MCCommand subclass: #MCVersionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCVersionCommand subclass: #MCCmdAdopt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdAdopt methodsFor: 'execution' stamp: 'avi 12/5/2007 13:32'!
execute
	target version adopt! !

!MCCmdAdopt methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:52'!
label
	^ 'adopt'! !

MCVersionCommand subclass: #MCCmdCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdCopy methodsFor: 'execution' stamp: 'avi 12/5/2007 13:33'!
execute
	self pickRepository ifNotNilDo:
		[:ea |
		ea storeVersion: target version]! !

!MCCmdCopy methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'copy to another repository'! !

!MCCmdCopy methodsFor: 'execution' stamp: 'dkh 12/14/2007 15:06'!
pickRepository 
	| repos labels |
	repos := MCRepositoryGroup default repositories.
	labels := repos collect: [:ea | ea description].
	^OBChoiceRequest 
			prompt: 'Copy to:' 
			labels: labels
			values: repos! !

MCVersionCommand subclass: #MCCmdLoad
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdLoad methodsFor: 'execution' stamp: 'dkh 01/11/2008 15:52'!
execute
	| version |
	version := target version.
	version load.
	version workingCopy repositoryGroup addRepository: target repository! !

!MCCmdLoad methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'load'! !

!MCCmdLoad methodsFor: 'accessing' stamp: 'dkh 9/12/2007 16:06'!
longDescription
	^ 'Erases all modifications made on your image for this package and load the selected version from the repository'! !

!MCCmdLoad methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:06'!
wantsButton
	^ true! !

MCVersionCommand subclass: #MCCmdMerge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdMerge methodsFor: 'execution' stamp: 'dkh 12/14/2007 11:20'!
execute
	| versionMerger |
	versionMerger _ MCVersionMerger new addVersion: target version.
	versionMerger applyRecords.
	versionMerger isAncestorMerge ifTrue: [^ OBInformRequest message: 'No changes'].
	MCMergeTool openRoot: (MCVersionMergerNode new versionMerger: versionMerger)! !

!MCCmdMerge methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'merge'! !

!MCCmdMerge methodsFor: 'accessing' stamp: 'dkh 9/12/2007 16:06'!
longDescription
	^ 'Displays the differences between what is in the repository and your image. Allows you to install some or all of the changes into your image.'! !

!MCCmdMerge methodsFor: 'testing' stamp: 'dkh 9/12/2007 16:06'!
wantsButton
	^ true! !

!MCVersionCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 13:13'!
isActive
	^ target hasVersion and: [requestor isSelected: target]! !

MCCommand subclass: #MCWorkingCopyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCWorkingCopyCommand subclass: #MCCmdAddRequiredPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdAddRequiredPackage methodsFor: 'execution' stamp: 'dkh 02/12/2008 15:52'!
execute
	(self pickWorkingCopySatisfying: [:aWorkingCopy | self selectWorkingCopyAsRequiredCandidate: aWorkingCopy]) ifNotNilDo:
		[:wc |
		target workingCopy requirePackage: wc package.
		self refresh]! !

!MCCmdAddRequiredPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:54'!
group
	^ #requiredPackages! !

!MCCmdAddRequiredPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'add required package'! !

!MCCmdAddRequiredPackage methodsFor: 'private' stamp: 'dkh 02/12/2008 16:21'!
selectWorkingCopyAsRequiredCandidate: aWorkingCopy

	| wc package aPackage seen remaining packages |
	wc := target workingCopy.
	aPackage := aWorkingCopy package.
	(wc requiredPackages includes: aPackage)
		ifTrue: [ ^false ].
	package := wc package.
	(package = aPackage)
		ifTrue: [ ^false ].
	"check for requiredPackages cycles"
	seen := IdentitySet new.
	packages := aWorkingCopy requiredPackages.
	[ | newPackages |
		newPackages := IdentitySet new.
		packages do: [:pkg | 
			pkg = package ifTrue: [ ^false ].
			(seen includes: pkg)
				ifFalse: [ newPackages addAll: pkg workingCopy requiredPackages ]].
		packages := newPackages.
		packages isEmpty] untilTrue.
	^true! !

!MCCmdAddRequiredPackage methodsFor: 'testing' stamp: 'dkh 12/14/2007 11:21'!
targetClass
	^ MCWorkingCopyNode! !

MCWorkingCopyCommand subclass: #MCCmdClearRequiredPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdClearRequiredPackage methodsFor: 'execution' stamp: 'avi 12/5/2007 11:14'!
execute
	target workingCopy clearRequiredPackages.
	self refresh! !

!MCCmdClearRequiredPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
group
	^ #requiredPackages! !

!MCCmdClearRequiredPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'clear required package'! !

!MCCmdClearRequiredPackage methodsFor: 'testing' stamp: 'dkh 12/14/2007 11:21'!
targetClass
	^ MCWorkingCopyNode! !

MCWorkingCopyCommand subclass: #MCCmdDeleteWorkingCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdDeleteWorkingCopy methodsFor: 'execution' stamp: 'avi 12/5/2007 09:40'!
execute
	target workingCopy unregister.
	self refresh! !

!MCCmdDeleteWorkingCopy methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'delete working copy'! !

MCWorkingCopyCommand subclass: #MCCmdRecompilePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRecompilePackage methodsFor: 'execution' stamp: 'avi 12/5/2007 11:13'!
execute
	target workingCopy package packageInfo methods do: [:ea | ea actualClass recompile: ea methodSymbol]! !

!MCCmdRecompilePackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'recompile package'! !

MCWorkingCopyCommand subclass: #MCCmdRemoveRequiredPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRemoveRequiredPackage methodsFor: 'execution' stamp: 'dkh 01/15/2008 11:22'!
execute
	self pickRequiredPackage ifNotNilDo:
		[:required |
		target workingCopy requiredPackages remove: required.
		self refresh]! !

!MCCmdRemoveRequiredPackage methodsFor: 'accessing' stamp: 'dkh 01/15/2008 11:21'!
group
	^ #requiredPackages! !

!MCCmdRemoveRequiredPackage methodsFor: 'accessing' stamp: 'dkh 01/15/2008 11:21'!
label
	^ 'remove required package'! !

!MCCmdRemoveRequiredPackage methodsFor: 'actions' stamp: 'dkh 01/15/2008 11:26'!
pickRequiredPackage
	| required |
	required  := target workingCopy requiredPackages.
	required isEmpty ifTrue: [ ^nil ].
	^OBChoiceRequest 
		prompt: 'Package:' 
		labels: (required collect: [:ea | ea name])
		values: required.! !

!MCCmdRemoveRequiredPackage methodsFor: 'testing' stamp: 'dkh 01/15/2008 11:21'!
targetClass
	^ MCWorkingCopyNode! !

MCWorkingCopyCommand subclass: #MCCmdUnloadPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdUnloadPackage methodsFor: 'execution' stamp: 'avi 12/5/2007 11:13'!
execute
	target workingCopy unload.
	self refresh! !

!MCCmdUnloadPackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:53'!
label
	^ 'unload package'! !

!MCWorkingCopyCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:53'!
group
	^ #workingCopy! !

!MCWorkingCopyCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 13:12'!
isActive
	^ target hasWorkingCopy and: [requestor isSelected: target]! !

MCCommand subclass: #MCWorkingCopyRepositoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

MCWorkingCopyRepositoryCommand subclass: #MCCmdRemoveRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRemoveRepository methodsFor: 'execution' stamp: 'avi 12/5/2007 10:52'!
execute
	target repositoryGroup removeRepository: target repository.
	self refresh! !

!MCCmdRemoveRepository methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:54'!
group
	^ #repository! !

!MCCmdRemoveRepository methodsFor: 'accessing' stamp: 'dkh 9/12/2007 16:07'!
keystroke
	^ $x! !

!MCCmdRemoveRepository methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:54'!
label
	^ 'remove repository'! !

MCWorkingCopyRepositoryCommand subclass: #MCCmdRevertPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdRevertPackage methodsFor: 'execution' stamp: 'dkh 02/22/2008 13:12'!
execute

	self pickAncestorVersionInfo ifNotNilDo: [:info |
		(self repositoryGroup versionWithInfo: info
			ifNone: [^self inform: 'No repository found for ', info name]
		) load]! !

!MCCmdRevertPackage methodsFor: 'accessing' stamp: 'dkh 02/22/2008 13:10'!
label
	^ 'revert package...'! !

!MCCmdRevertPackage methodsFor: 'private' stamp: ''!
pickAncestorVersionInfo
	| ancestors index |
	ancestors := self workingCopy ancestry breadthFirstAncestors.
	^OBChoiceRequest 
		prompt: 'Package:' 
		labels: (ancestors collect: [:ea | ea name])
		values: ancestors.
! !

MCWorkingCopyRepositoryCommand subclass: #MCCmdSavePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Commands'!

!MCCmdSavePackage methodsFor: 'private' stamp: 'dkh 02/22/2008 12:48'!
checkForNewerVersions
	| newer |
	newer := self workingCopy possiblyNewerVersionsIn: self repository.
	^ newer isEmpty or: [ | list |
		list := String streamContents: [:stream |
			newer do: [:ea | stream nextPutAll: ea, String cr]].
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, list,
			'Do you really want to save this version?'].! !

!MCCmdSavePackage methodsFor: 'execution' stamp: 'dkh 02/22/2008 12:37'!
execute
	| version v m |
	self checkForNewerVersions ifFalse: [^self].
	[version _ self workingCopy newVersion]
		on: MCVersionNameAndMessageRequest
		do: [:n |
			v _ OBTextRequest prompt: 'Please enter a name for your version:' template: n suggestedName.
			v ifNotNil:
				[m _ OBMultiLineTextRequest prompt: 'Please enter a commit message:'.
				m ifNotNil:
					[n resume: {v. m}]].
			n resume: nil].
	version ifNotNil:
		[self repository storeVersion: version.
		version allDependenciesDo:
			[:dep |
				(self repository includesVersionNamed: dep info name)
					ifFalse: [self repository storeVersion: dep]]].
	self refresh! !

!MCCmdSavePackage methodsFor: 'accessing' stamp: 'avi 12/4/2007 16:54'!
label
	^ 'save'! !

!MCCmdSavePackage methodsFor: 'testing' stamp: 'dkh 09/12/2007 20:08'!
wantsButton
	^ true! !

!MCWorkingCopyRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 16:54'!
group
	^ #workingCopy! !

!MCWorkingCopyRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 13:25'!
isActive
	^ target hasWorkingCopy and: [target hasRepository] and: [requestor isSelected: target]! !

!MCWorkingCopyRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/4/2007 15:43'!
repository
	^ target repository! !

!MCWorkingCopyRepositoryCommand methodsFor: 'private' stamp: 'dkh 02/22/2008 13:15'!
repositoryGroup

	^self workingCopy repositoryGroup! !

!MCWorkingCopyRepositoryCommand methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 13:23'!
workingCopy
	^ target workingCopy! !

OBFilter subclass: #MCModifiedFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Other'!

!MCModifiedFilter methodsFor: 'as yet unclassified' stamp: 'avi 12/7/2007 14:39'!
icon: aSymbol forNode: aNode
	(aNode hasWorkingCopy not or: [aNode workingCopy isNil]) ifTrue: [^ #blank].
	
	^ aNode workingCopy modified
		ifTrue: [#breakpoint]
		ifFalse: [aNode workingCopy needsSaving
					ifTrue: [#arrowDown]
					ifFalse: [#blank]]! !

OBInteractionRequest subclass: #MCDirectoryRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Monticello-Other'!

!MCDirectoryRequest methodsFor: 'dispatching' stamp: 'dkh 09/13/2007 13:55'!
handleWith: anObject
	^ anObject handleDirectoryRequest: self! !

!MCVersionMerger methodsFor: '*ob-monticello' stamp: 'avi 12/3/2007 16:31'!
applyRecords
	records do: [:ea | merger addBaseSnapshot: ea packageSnapshot].
	records do: [:ea | merger applyPatch: ea mergePatch]! !

!MCVersionMerger methodsFor: '*ob-monticello' stamp: 'avi 12/3/2007 16:33'!
isAncestorMerge
	^ records allSatisfy: [:ea | ea isAncestorMerge]! !

!MCVersionMerger methodsFor: '*ob-monticello' stamp: 'avi 12/3/2007 16:32'!
loadWithNameLike: aString
	aString ifNil: [merger load] ifNotNil: [merger loadWithNameLike: aString].
	records do: [:ea | ea updateWorkingCopy]! !

!MCVersionMerger methodsFor: '*ob-monticello' stamp: 'avi 12/3/2007 17:06'!
merger
	^ merger! !

!MCVersionMerger methodsFor: '*ob-monticello' stamp: 'avi 12/3/2007 16:51'!
mergeTitle
	^ 'Merging ', records first version info name! !

!MCAncestry methodsFor: '*ob-monticello' stamp: 'dkh 12/14/2007 11:17'!
asNode

	^MCAncestryNode on: self! !

!MCWorkingCopy methodsFor: '*ob-monticello' stamp: 'dkh 12/14/2007 11:20'!
asNode

	^MCWorkingCopyNode on: self! !

!MCWorkingCopy methodsFor: '*ob-monticello' stamp: 'dkh 01/15/2008 11:34'!
summary
	^ String streamContents:
		[:s |
		self modified ifTrue: [s nextPutAll: 'MODIFIED'; cr].
		s nextPutAll: self ancestry summary.
		self ancestry ancestors do:
			[:ea |
			s cr; cr.
			s nextPutAll: ea summary].
		self requiredPackages isEmpty ifFalse: [ s cr; cr; nextPutAll: 'Required: ' ].
		(self requiredPackages sortBy: [:a :b | a name <= b name]) do:
			[:ea |
			s nextPutAll: ea name, ', ']]
	! !

!MCHttpRepository class methodsFor: '*ob-monticello' stamp: 'dkh 12/14/2007 15:38'!
obConfigureFromTemplate: aString
	| chunk repo |
	chunk := OBTextRequest 
		prompt: self fillInTheBlankRequest 
		template: (aString ifNil: [self creationTemplate]).
	chunk 
		ifNotNil: [ 
			repo := self readFrom: chunk readStream.
			repo creationTemplate: chunk. 
	].

	^ repo! !
